/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_peephole2_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_10 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_11 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[0] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 51
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

static int
pattern4 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 51
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 51
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 51
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 51
      || GET_MODE (x5) != E_CC_FLOATmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SFmode))
    return -1;
  return 0;
}

static int
pattern9 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

static int
pattern10 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || !nonmemory_operand (operands[2], i2))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

static int
pattern11 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 51)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern10 (x1, E_CCmode, E_SImode); /* [-1, 0] */

        case E_SFmode:
          if (pattern10 (x1, E_CC_FLOATmode, E_SFmode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      if (pnum_clobbers == NULL)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern12 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 51
      || GET_MODE (x3) != i2
      || !register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

static int
pattern13 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != LTU
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

static int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern14 (x2); /* [-1, 0] */
}

static int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MINUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LTU
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

static int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MINUS
      || GET_MODE (x1) != E_SImode
      || pattern16 (x1) != 0)
    return -1;
  return 0;
}

static int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UMOD
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x2, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  operands[4] = x10;
  if (!nonmemory_operand (operands[4], E_SImode))
    return -1;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  return 0;
}

static int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MOD
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x2, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  operands[4] = x10;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  return 0;
}

static int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_CODE (x3))
    {
    case PLUS:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!nonmemory_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case MINUS:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!nonmemory_operand (operands[4], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[3] = x1;
      if (!register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case NEG:
      if (GET_MODE (x1) != E_SFmode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[3] = x2;
      if (!register_operand (operands[3], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern22 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x7, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x7, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

static int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 9
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

static int
pattern24 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MULT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x4, 0);
  if (!rtx_equal_p (x7, operands[3]))
    return -1;
  return 0;
}

static int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case ASHIFTRT:
      return pattern24 (x4, SIGN_EXTEND); /* [-1, 0] */

    case LSHIFTRT:
      if (pattern24 (x4, ZERO_EXTEND) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[3] = x1;
      if (!register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case NEG:
      if (GET_MODE (x1) != E_SFmode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[3] = x2;
      if (!register_operand (operands[3], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  if (!reg_or_am33_const_operand (operands[5], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x5, 1);
  if (!rtx_equal_p (x7, operands[4]))
    return -1;
  return 0;
}

static int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[4] = x3;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[5] = x4;
  if (!reg_or_am33_const_operand (operands[5], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[3]))
    return -1;
  x9 = XEXP (x5, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!label_ref_operand (operands[2], E_VOIDmode))
    return -1;
  if (ordered_comparison_operator (operands[3], E_VOIDmode))
    {
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (register_operand (operands[0], E_SImode))
        {
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          if (nonmemory_operand (operands[1], E_SImode))
            return 33; /* *cbranchsi4_cmp */
        }
    }
  if (!CCZN_comparison_operator (operands[3], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != AND
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x5, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x5, 1);
  operands[1] = x8;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  return 36; /* *cbranchsi4_btst */
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          switch (GET_CODE (x3))
            {
            case CONST_INT:
              if (XWINT (x3, 0) == 0LL)
                {
                  x4 = XVECEXP (x1, 0, 1);
                  if (pattern4 (x4, E_CCmode, 51) == 0)
                    {
                      x5 = XEXP (x2, 0);
                      operands[0] = x5;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_QImode:
                          if (register_operand (operands[0], E_QImode))
                            return 5; /* *movqi_clr */
                          break;

                        case E_HImode:
                          if (register_operand (operands[0], E_HImode))
                            return 6; /* *movhi_clr */
                          break;

                        case E_SImode:
                          if (register_operand (operands[0], E_SImode))
                            return 7; /* *movsi_clr */
                          break;

                        default:
                          break;
                        }
                    }
                }
              break;

            case REG:
            case SUBREG:
              operands[0] = x3;
              if (register_operand (operands[0], E_SImode))
                {
                  x5 = XEXP (x2, 0);
                  if (GET_CODE (x5) == PC)
                    {
                      x4 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x4) == USE)
                        {
                          x6 = XEXP (x4, 0);
                          if (GET_CODE (x6) == LABEL_REF)
                            {
                              x7 = XEXP (x6, 0);
                              operands[1] = x7;
                              return 43; /* tablejump */
                            }
                        }
                    }
                }
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          switch (pattern20 (x4))
            {
            case 0:
              *pnum_clobbers = 1;
              return 12; /* *adddi3_degenerate */

            case 1:
              *pnum_clobbers = 1;
              return 17; /* *subdi3_degenerate */

            default:
              return -1;
            }

        case PLUS:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              switch (pattern11 (x1, pnum_clobbers))
                {
                case 0:
                  return 8; /* addsi3 */

                case 1:
                  if (!
#line 1899 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 58; /* addsf3 */

                case 2:
                  x4 = XVECEXP (x1, 0, 1);
                  x9 = XEXP (x4, 1);
                  if (pattern15 (x9) != 0
                      || !register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  operands[2] = x8;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x10 = XEXP (x3, 1);
                  operands[3] = x10;
                  if (!nonmemory_operand (operands[3], E_SImode))
                    return -1;
                  x6 = XEXP (x4, 0);
                  operands[1] = x6;
                  if (!register_operand (operands[1], E_SImode)
                      || pattern28 (x9) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 11; /* adddi3_internal */

                default:
                  return -1;
                }

            case PLUS:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              x11 = XEXP (x8, 0);
              if (GET_CODE (x11) != LTU
                  || GET_MODE (x11) != E_SImode)
                return -1;
              x12 = XEXP (x11, 0);
              if (GET_CODE (x12) != REG
                  || REGNO (x12) != 51
                  || GET_MODE (x12) != E_CCmode)
                return -1;
              x13 = XEXP (x11, 1);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER
                  || pattern12 (x1, E_SImode, E_CCmode) != 0)
                return -1;
              x14 = XEXP (x8, 1);
              operands[1] = x14;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[2] = x10;
              if (!reg_or_am33_const_operand (operands[2], E_SImode)
                  || !
#line 625 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed))
                return -1;
              return 10; /* addc_internal */

            default:
              return -1;
            }

        case COMPARE:
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 51)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (pattern22 (x1, PLUS) != 0
                  || !
#line 601 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNCmode)))
                return -1;
              return 9; /* *addsi3_flags */

            case MINUS:
              if (pattern22 (x1, MINUS) != 0
                  || !
#line 799 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNCmode)))
                return -1;
              return 14; /* *subsi3_flags */

            case AND:
              if (pattern22 (x1, AND) != 0
                  || !
#line 1203 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNmode)))
                return -1;
              return 26; /* *andsi3_flags */

            case IOR:
              if (pattern22 (x1, IOR) != 0
                  || !
#line 1290 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNmode)))
                return -1;
              return 28; /* *iorsi3_flags */

            case XOR:
              if (pattern22 (x1, XOR) != 0
                  || !
#line 1326 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNmode)))
                return -1;
              return 30; /* *xorsi3_flags */

            case NOT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              x10 = XEXP (x3, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || GET_CODE (x9) != NOT)
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x15 = XEXP (x9, 0);
              if (!rtx_equal_p (x15, operands[1])
                  || !
#line 1353 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNmode)))
                return -1;
              return 32; /* *one_cmplsi2_flags */

            case REG:
            case SUBREG:
              operands[2] = x8;
              if (!register_operand (operands[2], E_SImode)
                  || GET_CODE (x9) != UNSPEC
                  || XVECLEN (x9, 0) != 3
                  || XINT (x9, 1) != 8
                  || GET_MODE (x5) != E_CCmode
                  || GET_MODE (x3) != E_CCmode)
                return -1;
              x10 = XEXP (x3, 1);
              operands[3] = x10;
              if (!liw_operand (operands[3], E_VOIDmode))
                return -1;
              x16 = XVECEXP (x9, 0, 1);
              operands[1] = x16;
              if (!liw_operand (operands[1], E_VOIDmode))
                return -1;
              x17 = XVECEXP (x9, 0, 2);
              operands[4] = x17;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x18 = XVECEXP (x9, 0, 0);
              if (!rtx_equal_p (x18, operands[0])
                  || !
#line 2161 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_ALLOW_LIW))
                return -1;
              return 73; /* cmp_liw */

            default:
              return -1;
            }

        case MINUS:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              switch (pattern11 (x1, pnum_clobbers))
                {
                case 0:
                  return 13; /* subsi3 */

                case 1:
                  if (!
#line 1916 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 59; /* subsf3 */

                case 2:
                  x4 = XVECEXP (x1, 0, 1);
                  x9 = XEXP (x4, 1);
                  if (pattern17 (x9) != 0
                      || !register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  operands[2] = x8;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x10 = XEXP (x3, 1);
                  operands[4] = x10;
                  if (!nonmemory_operand (operands[4], E_SImode))
                    return -1;
                  x6 = XEXP (x4, 0);
                  operands[1] = x6;
                  if (!register_operand (operands[1], E_SImode)
                      || pattern27 (x9) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 16; /* subdi3_internal */

                default:
                  return -1;
                }

            case MINUS:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              x10 = XEXP (x3, 1);
              if (GET_CODE (x10) != GEU
                  || GET_MODE (x10) != E_SImode)
                return -1;
              x19 = XEXP (x10, 0);
              if (GET_CODE (x19) != REG
                  || REGNO (x19) != 51
                  || GET_MODE (x19) != E_CCmode)
                return -1;
              x20 = XEXP (x10, 1);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER
                  || pattern12 (x1, E_SImode, E_CCmode) != 0)
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x14 = XEXP (x8, 1);
              operands[2] = x14;
              if (!reg_or_am33_const_operand (operands[2], E_SImode)
                  || !
#line 825 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed))
                return -1;
              return 15; /* subc_internal */

            default:
              return -1;
            }

        case NEG:
          if (pattern5 (x1) != 0)
            return -1;
          return 18; /* negsi2 */

        case MULT:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x4 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x4))
            {
            case SET:
              if (pnum_clobbers == NULL)
                return -1;
              x9 = XEXP (x4, 1);
              if (GET_CODE (x9) != TRUNCATE
                  || GET_MODE (x9) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x8 = XEXP (x3, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[3] = x10;
              switch (pattern25 (x4))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 19; /* mulsidi3_internal */

                case 1:
                  *pnum_clobbers = 1;
                  return 20; /* umulsidi3_internal */

                default:
                  return -1;
                }

            case CLOBBER:
              if (pattern12 (x1, E_SFmode, E_CC_FLOATmode) != 0)
                return -1;
              x8 = XEXP (x3, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_SFmode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[2] = x10;
              if (!nonmemory_operand (operands[2], E_SFmode)
                  || !
#line 1934 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              return 60; /* mulsf3 */

            default:
              return -1;
            }

        case AND:
          if (pattern6 (x1) != 0)
            return -1;
          return 25; /* andsi3 */

        case IOR:
          if (pattern6 (x1) != 0)
            return -1;
          return 27; /* iorsi3 */

        case XOR:
          if (pattern6 (x1) != 0)
            return -1;
          return 29; /* xorsi3 */

        case NOT:
          if (pattern5 (x1) != 0)
            return -1;
          return 31; /* one_cmplsi2 */

        case ASHIFT:
          if (pattern7 (x1) != 0)
            return -1;
          return 51; /* ashlsi3 */

        case LSHIFTRT:
          if (pattern7 (x1) != 0)
            return -1;
          return 52; /* lshrsi3 */

        case ASHIFTRT:
          if (pattern7 (x1) != 0)
            return -1;
          return 53; /* ashrsi3 */

        case UNSPEC:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (XVECLEN (x3, 0))
            {
            case 2:
              if (XINT (x3, 1) != 7)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (pattern4 (x4, E_CCmode, 51) != 0)
                return -1;
              x21 = XVECEXP (x3, 0, 0);
              operands[1] = x21;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x22 = XVECEXP (x3, 0, 1);
              operands[2] = x22;
              if (!nonmemory_operand (operands[2], E_SImode)
                  || !
#line 1839 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33))
                return -1;
              return 54; /* *bsch */

            case 1:
              if (XINT (x3, 1) != 2)
                return -1;
              x21 = XVECEXP (x3, 0, 0);
              if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x6 = XEXP (x4, 0);
              switch (GET_CODE (x6))
                {
                case REG:
                  if (REGNO (x6) != 51
                      || GET_MODE (x6) != E_CCmode
                      || !
#line 2087 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33))
                    return -1;
                  return 69; /* am33_load_pic */

                case MEM:
                  if (pnum_clobbers == NULL
                      || pattern23 (x6) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 71; /* mn10300_load_pic1 */

                default:
                  return -1;
                }

            case 3:
              if (XINT (x3, 1) != 8)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              x22 = XVECEXP (x3, 0, 1);
              if (!liw_operand (x22, E_VOIDmode))
                return -1;
              x23 = XVECEXP (x3, 0, 2);
              operands[4] = x23;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x21 = XVECEXP (x3, 0, 0);
              if (!rtx_equal_p (x21, operands[0]))
                return -1;
              x9 = XEXP (x4, 1);
              switch (GET_CODE (x9))
                {
                case UNSPEC:
                  if (XVECLEN (x9, 0) != 3
                      || XINT (x9, 1) != 8
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  operands[2] = x22;
                  x6 = XEXP (x4, 0);
                  operands[1] = x6;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x16 = XVECEXP (x9, 0, 1);
                  operands[3] = x16;
                  if (!liw_operand (operands[3], E_VOIDmode))
                    return -1;
                  x17 = XVECEXP (x9, 0, 2);
                  operands[5] = x17;
                  if (!const_int_operand (operands[5], E_SImode))
                    return -1;
                  x18 = XVECEXP (x9, 0, 0);
                  if (!rtx_equal_p (x18, operands[1])
                      || !
#line 2144 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_ALLOW_LIW))
                    return -1;
                  return 72; /* liw */

                case COMPARE:
                  if (GET_MODE (x9) != E_CCmode)
                    return -1;
                  x6 = XEXP (x4, 0);
                  if (GET_CODE (x6) != REG
                      || REGNO (x6) != 51
                      || GET_MODE (x6) != E_CCmode)
                    return -1;
                  operands[1] = x22;
                  x15 = XEXP (x9, 0);
                  operands[2] = x15;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x24 = XEXP (x9, 1);
                  operands[3] = x24;
                  if (!liw_operand (operands[3], E_VOIDmode)
                      || !
#line 2176 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_ALLOW_LIW))
                    return -1;
                  return 74; /* liw_cmp */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case DIV:
          if (pattern8 (x1) != 0)
            return -1;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
              operands[2] = x8;
              if (!const_1f_operand (operands[2], E_SFmode))
                return -1;
              x10 = XEXP (x3, 1);
              if (GET_CODE (x10) != SQRT
                  || GET_MODE (x10) != E_SFmode)
                return -1;
              x19 = XEXP (x10, 0);
              operands[1] = x19;
              if (!register_operand (operands[1], E_SFmode)
                  || !
#line 1886 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              return 57; /* rsqrtsf2 */

            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!register_operand (operands[1], E_SFmode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[2] = x10;
              if (!nonmemory_operand (operands[2], E_SFmode)
                  || !
#line 1951 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              return 61; /* divsf3 */

            default:
              return -1;
            }

        case FMA:
          if (pattern8 (x1) != 0)
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SFmode))
            return -1;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!register_operand (operands[1], E_SFmode))
                return -1;
              x25 = XEXP (x3, 2);
              switch (pattern26 (x25))
                {
                case 0:
                  if (!
#line 1970 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 62; /* fmasf4 */

                case 1:
                  if (!
#line 1983 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 63; /* fmssf4 */

                default:
                  return -1;
                }

            case NEG:
              if (GET_MODE (x8) != E_SFmode)
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SFmode))
                return -1;
              x25 = XEXP (x3, 2);
              switch (pattern26 (x25))
                {
                case 0:
                  if (!
#line 1996 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 64; /* fnmasf4 */

                case 1:
                  if (!
#line 2009 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 65; /* fnmssf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x8 = XEXP (x3, 0);
          if (!comparison_operator (x8, E_VOIDmode))
            return -1;
          operands[0] = x8;
          x11 = XEXP (x8, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 51)
            return -1;
          x14 = XEXP (x8, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x3, 1);
          if (GET_CODE (x10) != LABEL_REF)
            return -1;
          x25 = XEXP (x3, 2);
          if (GET_CODE (x25) != PC)
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != PC)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != UNSPEC
              || XVECLEN (x4, 0) != 1
              || XINT (x4, 1) != 9)
            return -1;
          x26 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x26) != CONST_INT)
            return -1;
          x19 = XEXP (x10, 0);
          operands[1] = x19;
          switch (XWINT (x26, 0))
            {
            case 1LL:
              if (GET_MODE (x11) != E_CCmode
                  || !
#line 2202 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33 && TARGET_ALLOW_SETLB))
                return -1;
              return 76; /* Lcc */

            case 2LL:
              if (GET_MODE (x11) != E_CC_FLOATmode
                  || !
#line 2213 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2 && TARGET_ALLOW_SETLB))
                return -1;
              return 77; /* FLcc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!const_int_operand (operands[0], E_SImode))
        return -1;
      return 67; /* return_ret */

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET
      || pattern3 (x1) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (pattern15 (x5) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      if (!nonmemory_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x5, 0);
      x11 = XEXP (x10, 1);
      operands[4] = x11;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x12 = XEXP (x5, 1);
      operands[5] = x12;
      if (!reg_or_am33_const_operand (operands[5], E_SImode))
        return -1;
      x13 = XEXP (x6, 0);
      operands[6] = x13;
      if (!scratch_operand (operands[6], E_SImode))
        return -1;
      x14 = XEXP (x10, 0);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      x17 = XEXP (x15, 1);
      if (!rtx_equal_p (x17, operands[3]))
        return -1;
      x18 = XEXP (x14, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      return 11; /* adddi3_internal */

    case MINUS:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (pattern17 (x5) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[4] = x8;
      if (!nonmemory_operand (operands[4], E_SImode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x5, 0);
      x14 = XEXP (x10, 0);
      operands[3] = x14;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x11 = XEXP (x10, 1);
      operands[5] = x11;
      if (!reg_or_am33_const_operand (operands[5], E_SImode))
        return -1;
      x13 = XEXP (x6, 0);
      operands[6] = x13;
      if (!scratch_operand (operands[6], E_SImode))
        return -1;
      x12 = XEXP (x5, 1);
      x19 = XEXP (x12, 0);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      x20 = XEXP (x12, 1);
      if (!rtx_equal_p (x20, operands[4]))
        return -1;
      return 16; /* subdi3_internal */

    case UDIV:
      if (pattern18 (x1) != 0)
        return -1;
      return 22; /* *udivmodsi4 */

    case DIV:
      if (pattern19 (x1) != 0)
        return -1;
      return 24; /* *divmodsi4 */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 2)
        return -1;
      x21 = XVECEXP (x3, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x9 = XEXP (x4, 0);
      if (GET_CODE (x9) != MEM
          || pattern23 (x9) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (pattern9 (x6, E_SImode, 50) != 0)
        return -1;
      return 71; /* mn10300_load_pic1 */

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x4;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (pattern9 (x6, E_CCmode, 51) != 0)
        return -1;
      switch (pattern20 (x5))
        {
        case 0:
          return 12; /* *adddi3_degenerate */

        case 1:
          return 17; /* *subdi3_degenerate */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (pattern9 (x6, E_CCmode, 51) != 0)
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case SET:
          x9 = XEXP (x5, 1);
          if (GET_CODE (x9) != TRUNCATE
              || GET_MODE (x9) != E_SImode)
            return -1;
          switch (pattern25 (x5))
            {
            case 0:
              return 19; /* mulsidi3_internal */

            case 1:
              return 20; /* umulsidi3_internal */

            default:
              return -1;
            }

        case CLOBBER:
          if (!reg_or_am33_const_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          if (!scratch_operand (operands[1], E_SImode))
            return -1;
          return 21; /* *mulsi3 */

        default:
          return -1;
        }

    case UDIV:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode
          || pattern18 (x1) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 22; /* *udivmodsi4 */

    case DIV:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode
          || pattern19 (x1) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 24; /* *divmodsi4 */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 2
          || GET_MODE (x4) != E_SImode)
        return -1;
      x11 = XVECEXP (x4, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern4 (x5, E_SImode, 50) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (pattern9 (x6, E_CCmode, 51) != 0)
        return -1;
      return 70; /* mn10300_load_pic0 */

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x3;
          operands[1] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (nonimmediate_operand (operands[0], E_QImode)
                  && general_operand (operands[1], E_QImode)
                  && 
#line 244 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((register_operand (operands[0], QImode)
    || register_operand (operands[1], QImode))))
                return 1; /* *movqi_internal */
              break;

            case E_HImode:
              if (nonimmediate_operand (operands[0], E_HImode)
                  && general_operand (operands[1], E_HImode)
                  && 
#line 292 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
((register_operand (operands[0], HImode)
    || register_operand (operands[1], HImode))))
                return 2; /* *movhi_internal */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && general_operand (operands[1], E_SImode)
                  && 
#line 435 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(register_operand (operands[0], SImode)
   || register_operand (operands[1], SImode)))
                return 3; /* *movsi_internal */
              break;

            case E_SFmode:
              if (nonimmediate_operand (operands[0], E_SFmode)
                  && general_operand (operands[1], E_SFmode)
                  && 
#line 506 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SFmode))))
                return 4; /* *movsf_internal */
              break;

            default:
              break;
            }
          break;

        case PC:
          operands[0] = x2;
          if (register_operand (operands[0], E_SImode))
            return 42; /* indirect_jump */
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case CONST_INT:
          if (pnum_clobbers == NULL
              || XWINT (x2, 0) != 0LL)
            return -1;
          switch (pattern2 (x3))
            {
            case 0:
              *pnum_clobbers = 1;
              return 5; /* *movqi_clr */

            case 1:
              *pnum_clobbers = 1;
              return 6; /* *movhi_clr */

            case 2:
              *pnum_clobbers = 1;
              return 7; /* *movsi_clr */

            default:
              return -1;
            }

        case LABEL_REF:
          if (GET_CODE (x3) != PC)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 41; /* jump */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern13 (x2, E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 8; /* addsi3 */

            case E_SFmode:
              if (pattern13 (x2, E_SFmode) != 0
                  || !
#line 1899 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 58; /* addsf3 */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != LTU
              || GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 51
              || GET_MODE (x7) != E_CCmode)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x9 = XEXP (x4, 1);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode)
              || !reg_or_am33_const_operand (operands[2], E_SImode)
              || !
#line 625 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 10; /* addc_internal */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern13 (x2, E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 13; /* subsi3 */

            case E_SFmode:
              if (pattern13 (x2, E_SFmode) != 0
                  || !
#line 1916 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 59; /* subsf3 */

            default:
              return -1;
            }

        case MINUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != GEU
              || GET_MODE (x5) != E_SImode)
            return -1;
          x10 = XEXP (x5, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 51
              || GET_MODE (x10) != E_CCmode)
            return -1;
          x11 = XEXP (x5, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (!reg_or_am33_const_operand (operands[2], E_SImode)
              || !
#line 825 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 15; /* subc_internal */

        default:
          return -1;
        }

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 18; /* negsi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 1861 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
            return -1;
          return 56; /* negsf2 */

        default:
          return -1;
        }

    case MULT:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!reg_or_am33_const_operand (operands[3], E_SImode))
            return -1;
          *pnum_clobbers = 2;
          return 21; /* *mulsi3 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_SFmode)
              || !
#line 1934 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
            return -1;
          *pnum_clobbers = 1;
          return 60; /* mulsf3 */

        default:
          return -1;
        }

    case UNSPEC:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          switch (XINT (x2, 1))
            {
            case 6:
              x12 = XVECEXP (x2, 0, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              return 23; /* ext_internal */

            case 2:
              if (pnum_clobbers == NULL)
                return -1;
              x12 = XVECEXP (x2, 0, 0);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              if (
#line 2087 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33))
                {
                  *pnum_clobbers = 1;
                  return 69; /* am33_load_pic */
                }
              *pnum_clobbers = 2;
              return 70; /* mn10300_load_pic0 */

            default:
              return -1;
            }

        case 2:
          if (pnum_clobbers == NULL
              || XINT (x2, 1) != 7)
            return -1;
          x12 = XVECEXP (x2, 0, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x13 = XVECEXP (x2, 0, 1);
          operands[2] = x13;
          if (!nonmemory_operand (operands[2], E_SImode)
              || !
#line 1839 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33))
            return -1;
          *pnum_clobbers = 1;
          return 54; /* *bsch */

        default:
          return -1;
        }

    case AND:
      if (pattern0 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 25; /* andsi3 */

    case IOR:
      if (pattern0 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 27; /* iorsi3 */

    case XOR:
      if (pattern0 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 29; /* xorsi3 */

    case NOT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 31; /* one_cmplsi2 */

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          x14 = XEXP (x2, 2);
          if (GET_CODE (x14) != PC)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              res = recog_1 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) == REG)
            {
              operands[2] = x6;
              if (int_mode_flags (operands[2], E_VOIDmode))
                {
                  x9 = XEXP (x4, 1);
                  if (x9 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    {
                      x5 = XEXP (x2, 1);
                      if (GET_CODE (x5) == LABEL_REF)
                        {
                          operands[0] = x4;
                          if (comparison_operator (operands[0], E_VOIDmode))
                            {
                              x10 = XEXP (x5, 0);
                              operands[1] = x10;
                              if (
#line 1422 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed))
                                return 35; /* *integer_conditional_branch */
                            }
                        }
                    }
                }
              if (REGNO (x6) == 51
                  && GET_MODE (x6) == E_CC_FLOATmode)
                {
                  x9 = XEXP (x4, 1);
                  if (x9 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    {
                      x5 = XEXP (x2, 1);
                      if (GET_CODE (x5) == LABEL_REF)
                        {
                          operands[0] = x4;
                          if (comparison_operator (operands[0], E_VOIDmode))
                            {
                              x10 = XEXP (x5, 0);
                              operands[1] = x10;
                              if (
#line 1499 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2 && reload_completed))
                                return 40; /* *float_conditional_branch */
                            }
                        }
                    }
                }
            }
          if (!ordered_comparison_operator (x4, E_VOIDmode))
            return -1;
          operands[3] = x4;
          operands[0] = x6;
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[1] = x9;
          if (!nonmemory_operand (operands[1], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!label_ref_operand (operands[2], E_VOIDmode)
              || !
#line 1474 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
            return -1;
          return 38; /* *cbranchsf4_cmp */

        default:
          return -1;
        }

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 51)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[0] = x4;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (nonmemory_operand (operands[1], E_SImode)
              && register_operand (operands[0], E_SImode)
              && 
#line 1395 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed))
            return 34; /* cmpsi */
          if (!nonmemory_operand (operands[1], E_SFmode)
              || GET_MODE (x3) != E_CC_FLOATmode
              || GET_MODE (x2) != E_CC_FLOATmode
              || !register_operand (operands[0], E_SFmode)
              || !
#line 1487 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2 && reload_completed))
            return -1;
          return 39; /* *am33_cmpsf */

        case AND:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_CCZNmode
              || GET_MODE (x2) != E_CCZNmode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[1] = x9;
          if (!immediate_operand (operands[1], E_SImode)
              || !
#line 1450 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed))
            return -1;
          return 37; /* *btstsi */

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!call_address_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      return 45; /* call_value_internal */

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 47; /* zero_extendqisi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 48; /* zero_extendhisi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 49; /* extendqisi2 */

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 50; /* extendhisi2 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern1 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 51; /* ashlsi3 */

    case LSHIFTRT:
      if (pattern1 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 52; /* lshrsi3 */

    case ASHIFTRT:
      if (pattern1 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 53; /* ashrsi3 */

    case ABS:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 1850 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
        return -1;
      return 55; /* abssf2 */

    case DIV:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_DOUBLE:
          operands[2] = x4;
          if (!const_1f_operand (operands[2], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != SQRT
              || GET_MODE (x5) != E_SFmode)
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 1886 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
            return -1;
          *pnum_clobbers = 1;
          return 57; /* rsqrtsf2 */

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_SFmode)
              || !
#line 1951 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
            return -1;
          *pnum_clobbers = 1;
          return 61; /* divsf3 */

        default:
          return -1;
        }

    case FMA:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          x14 = XEXP (x2, 2);
          switch (pattern21 (x14))
            {
            case 0:
              if (!
#line 1970 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 62; /* fmasf4 */

            case 1:
              if (!
#line 1983 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 63; /* fmssf4 */

            default:
              return -1;
            }

        case NEG:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          x14 = XEXP (x2, 2);
          switch (pattern21 (x14))
            {
            case 0:
              if (!
#line 1996 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 64; /* fnmasf4 */

            case 1:
              if (!
#line 2009 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 65; /* fnmssf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_5 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_4 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 1)
        return -1;
      operands[0] = x1;
      if (!mn10300_store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PLUS
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 9
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 9
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      return 68; /* store_movm */

    case CALL:
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      if (!call_address_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x1, 1);
      operands[1] = x9;
      return 44; /* *call_internal */

    case CONST_INT:
      if (XWINT (x1, 0) != 0LL)
        return -1;
      return 46; /* nop */

    case RETURN:
      if (!
#line 2032 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(mn10300_can_use_rets_insn ()))
        return -1;
      return 66; /* return */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 9)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !
#line 2191 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33 && TARGET_ALLOW_SETLB))
        return -1;
      return 75; /* setlb */

    default:
      return -1;
    }
}

static rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != PC)
    return NULL;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return NULL;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  x8 = XEXP (x2, 1);
  operands[2] = x8;
  if (!label_ref_operand (operands[2], E_VOIDmode))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !nonmemory_operand (operands[1], E_SImode)
          || !
#line 1384 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed))
        return NULL;
      return gen_split_9 (insn, operands);

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !nonmemory_operand (operands[1], E_SFmode)
          || !(
#line 1474 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2) && 
#line 1476 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
( reload_completed)))
        return NULL;
      return gen_split_11 (insn, operands);

    default:
      return NULL;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != SET)
            return NULL;
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != CLOBBER
              || pattern3 (x1) != 0)
            return NULL;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x3, 1);
          if (GET_MODE (x6) != E_SImode)
            return NULL;
          x7 = XEXP (x4, 0);
          operands[6] = x7;
          if (!scratch_operand (operands[6], E_SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (GET_CODE (x6) != PLUS)
                return NULL;
              x9 = XEXP (x6, 0);
              if (pattern14 (x9) != 0)
                return NULL;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (!nonmemory_operand (operands[3], E_SImode)
                  || pattern28 (x6) != 0
                  || !
#line 676 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed))
                return NULL;
              return gen_split_1 (insn, operands);

            case MINUS:
              if (GET_CODE (x6) != MINUS
                  || pattern16 (x6) != 0)
                return NULL;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x11 = XEXP (x8, 1);
              operands[4] = x11;
              if (!nonmemory_operand (operands[4], E_SImode)
                  || pattern27 (x6) != 0
                  || !
#line 877 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed))
                return NULL;
              return gen_split_3 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != SET)
            return NULL;
          x4 = XVECEXP (x1, 0, 2);
          if (pattern9 (x4, E_CCmode, 51) != 0)
            return NULL;
          x12 = XEXP (x2, 0);
          operands[0] = x12;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (!nonmemory_operand (operands[2], E_SImode))
            return NULL;
          switch (pattern20 (x3))
            {
            case 0:
              return gen_split_2 (insn, operands);

            case 1:
              return gen_split_4 (insn, operands);

            default:
              return NULL;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 1);
          if (pattern4 (x3, E_CCmode, 51) != 0)
            return NULL;
          x12 = XEXP (x2, 0);
          operands[0] = x12;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (GET_MODE (x8) != E_SImode)
            return NULL;
          switch (GET_CODE (x8))
            {
            case NEG:
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (!register_operand (operands[1], E_SImode)
                  || !
#line 968 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
( reload_completed))
                return NULL;
              return gen_split_5 (insn, operands);

            case AND:
              x11 = XEXP (x8, 1);
              if (GET_CODE (x11) != CONST_INT)
                return NULL;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (register_operand (operands[1], E_SImode))
                {
                  switch (XWINT (x11, 0))
                    {
                    case 255LL:
                      return gen_split_6 (insn, operands);

                    case 65535LL:
                      return gen_split_7 (insn, operands);

                    default:
                      break;
                    }
                }
              operands[1] = x11;
              if (!const_int_operand (operands[1], E_SImode)
                  || !rtx_equal_p (x10, operands[0])
                  || !
#line 1244 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed
   && REGNO_DATA_P (true_regnum (operands[0]), 1)
   && mn10300_split_and_operand_count (operands[1]) != 0))
                return NULL;
              return gen_split_8 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SET:
      x13 = XEXP (x1, 1);
      if (GET_CODE (x13) != IF_THEN_ELSE)
        return NULL;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[3] = x14;
          if (ordered_comparison_operator (operands[3], E_VOIDmode))
            {
              res = split_1 (x1, insn);
              if (res != NULL_RTX)
                return res;
            }
          if (!CCZN_comparison_operator (operands[3], E_VOIDmode))
            return NULL;
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != AND
              || GET_MODE (x15) != E_SImode)
            return NULL;
          x16 = XEXP (x14, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x17 = XEXP (x13, 2);
          if (GET_CODE (x17) != PC)
            return NULL;
          x18 = XEXP (x1, 0);
          if (GET_CODE (x18) != PC)
            return NULL;
          x19 = XEXP (x15, 0);
          operands[0] = x19;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x20 = XEXP (x15, 1);
          operands[1] = x20;
          if (!immediate_operand (operands[1], E_SImode))
            return NULL;
          x21 = XEXP (x13, 1);
          operands[2] = x21;
          if (!label_ref_operand (operands[2], E_VOIDmode)
              || !
#line 1437 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(reload_completed))
            return NULL;
          return gen_split_10 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x3 = XEXP (x1, 0);
  switch (pattern2 (x3))
    {
    case 0:
      if (!
#line 562 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(peep2_regno_dead_p (0, CC_REG)
   && (REGNO_DATA_P (REGNO (operands[0]), 1)
       || REGNO_EXTENDED_P (REGNO (operands[0]), 1))))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_1 (insn, operands);

    case 1:
      if (!
#line 562 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(peep2_regno_dead_p (0, CC_REG)
   && (REGNO_DATA_P (REGNO (operands[0]), 1)
       || REGNO_EXTENDED_P (REGNO (operands[0]), 1))))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_2 (insn, operands);

    case 2:
      if (!
#line 562 "../../gcc-10.2.1-20200826/gcc/config/mn10300/mn10300.md"
(peep2_regno_dead_p (0, CC_REG)
   && (REGNO_DATA_P (REGNO (operands[0]), 1)
       || REGNO_EXTENDED_P (REGNO (operands[0]), 1))))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_3 (insn, operands);

    default:
      return NULL;
    }
}
